<template>
  <div class="flex justify-start gap-[25px]">
    <div
      class="card-entry"
      :class="{ active: index === 0 }"
      v-for="(entry, index) in images"
      :key="index"
      @click="handleCardClick($event, entry.HyperLink)"
    >
      <img
        :src="
          entry.IsDefault && entry.HyperLink !== ''
            ? getYoutubeThumbnail(entry.HyperLink)
            : entry.ImagePath
        "
      />
      <div class="content">
        <div :class="`text-content-${entry.HtmlId} h-[58px] truncate`">
          {{ getContent(entry.HtmlId, entry.HyperLink) }}
        </div>
      </div>
    </div>
  </div>
</template>

<script lang="ts">
import { computed, defineComponent, PropType, ref } from "vue";
import { IThemePropertiesFromApi } from "@/models/companyThemePropertiesRespone";
import { store } from "@/store";
import themePropertyHelper from "@/utils/themePropertyHelper";

export default defineComponent({
  props: {
    images: {
      type: Array as PropType<Array<IThemePropertiesFromApi>>,
    },
    contentKey: {
      type: String,
      required: true,
    },
  },
  setup(props, { emit }) {
    const themeProperties = computed(
      () => store.state.companyThemePropertiesFromApi.ThemeProperties
    );
    const cardTitle = ref("");
    const getTitle = async (link: string): Promise<void> => {
      await fetch(`https://noembed.com/embed?url=${link}`).then(
        async (response) => {
          const dataResponse = await response.json();
          cardTitle.value = dataResponse.title;
        }
      );
    };
    const getContent = async (htmlId: string, hyperLink: string) => {
      const key = htmlId.split("_").pop();
      const theme = themePropertyHelper.getSingleThemeProperty(
        themeProperties.value,
        `${props.contentKey}${key}`
      );
      await getTitle(hyperLink);
      cardTitle.value = theme.IsDefault ? cardTitle.value : theme.Text;
      const textContent = document.querySelector(
        `.card-entry .text-content-${htmlId}`
      );
      if (textContent) textContent.textContent = cardTitle.value;
    };
    const handleCardClick = (event: Event, link: string): void => {
      const element = event.target as HTMLElement;
      const card = element.closest(".card-entry");
      if (!card?.classList.contains("active")) {
        element
          .closest("div.flex")
          ?.querySelectorAll(".card-entry.active")
          .forEach((c) => {
            c.classList.remove("active");
          });
        card?.classList.add("active");
        emit("handleClick", link);
      }
    };
    const getYoutubeThumbnail = (link: string) => {
      const url = link;
      const videoId = url.split("v=")[1];
      const imageUrl = `https://img.youtube.com/vi/${videoId}/hqdefault.jpg`;
      return imageUrl;
    };
    return {
      getContent,
      handleCardClick,
      getYoutubeThumbnail,
      cardTitle,
    };
  },
});
</script>

<style scoped lang="scss">
.card-entry {
  min-width: 220px;
  max-width: 220px;
  min-height: 208px;
  background-color: var(--background5);
  border-radius: 8px;
  overflow: hidden;
  margin: 0.5rem 0;
  color: var(--text3);
  cursor: pointer;
  img {
    -webkit-filter: grayscale(95%);
    filter: grayscale(95%);
    width: 100%;
    height: 124px;
    object-fit: cover;
  }

  .content {
    height: 84px;
    padding: 0.75rem 1rem;
    font-size: 16px;
    font-weight: 700;
    line-height: 19px;
    font-family: "Roboto";
    font-style: normal;
    flex: none;
    order: 0;
    flex-grow: 0;
    opacity: 0.8;
    .truncate {
      white-space: pre-wrap;
      display: -webkit-box;
      -webkit-box-orient: vertical;
      -webkit-line-clamp: 3;
    }
  }

  &.active {
    color: var(--selected);

    img {
      -webkit-filter: unset;
      filter: unset;
    }
  }
}
</style>
